/*
Utilitaire pour la synthèse vocale :
	- inspiré du tutoriel http://monwebfacile.free.fr/Tutoriaux/Javascript/JVS_SyntheseVocale.php
	

Instructions pour l'utiliser (voir demo_son1.html par exemple) :

	<pre id="informations"></pre> (facultatif)
	
	parle(...); // pour chaque message vocal

*/

			
			// -------------------
			// Variables générales
			// -------------------
			
			var synth;
			var utt;

			var refLangValue = "fr-FR";
			
			var pitchValue = 1;
			var rateValue = 1;
			var volumeValue = 1;

			var currentVoiceLang = "fr-FR"; // lang
			var currentVoiceTheme = ""; // name
			var	currentVoicelocalService = "";
			var	currentVoiceURI = "";
			
			var currentPitchValue = 1;
			var currentRateValue = 1;
			var currentVolumeValue = 1;

			// Initialisation de la synthèse
			// -----------------------------

			function initSynthese(){
				try{
					synth = window.speechSynthesis;
					utt = new SpeechSynthesisUtterance();
					return true;
				}
				catch(e) {return false;}
			}
			
			// Initialisation de l'utterance
			// -----------------------------
			function setUtterance(_lang,_voiceTheme,_volume,_pitch,_rate){
				try{
					utt.volume = _volume; // 0 à 1
					utt.pitch = _pitch; //0 à 2
					utt.rate = _rate; // 0.1 à 10
					return true;
				}
				catch(e){return false;}
			}
			
			// Initialisation des évènements de l'utterance
			// --------------------------------------------
			function setUtteranceEvents(){
				try{
					// Initialisation des évènements
					utt.onend = function(event) { displayInfo("Fin de la synthèse(onend)"); }
					utt.onerror = function(event) { displayInfo("Erreur durant le rendu vocal (onerror)"); }
					utt.onstart = function(event) { displayInfo("Démarrage de la synthèse (onstart)"); }
					utt.onpause = function(event) { displayInfo('Mise en pause (onpause)'); }
					utt.onresume = function(event) { displayInfo("Fin de pause (onresume)"); }
				}
				catch(e){displayInfo("Erreur d'initialisation des évènements de utterance : " + e);}
			}
			
			// Démarrage de la synthèse
			// ------------------------
			function parle(texte){
				try{
					initSynthese();
					setUtterance(currentVoiceLang,currentVoiceTheme,currentVolumeValue,currentPitchValue,currentRateValue);
					setUtteranceEvents();
					utt.text = texte;
					synth.speak(utt);			
				}
				catch(e){
					displayInfo("probleme de synthese vocale");
				}
			}	
			
		// -------------------------------------------------------------------------------
		// -------------------------------------------------------------------------------			
									
			// Affichage des informations
			// --------------------------
		
			function displayInfo(_info,_id){
				_id = _id || 'informations';
				var x = document.getElementById(_id);
				if (x==null) return;
				x.innerHTML = _info;
			}


